package observer;

import java.util.Iterator;

public aspect ObservingClose extends ObserverProtocol {
	declare parents: Flower implements Subject;
	declare parents: (Bee || Hummingbird) implements Observer;

	public abstract void Observer.bedtimeSleep();
	private boolean Subject.alreadyClosed = false;

	protected pointcut subjectChange(Subject subject):
		execution(void Subject+.close()) && this(subject);
	after(Subject subject): subjectChange(subject) {
		Flower f = (Flower)subject;
		if(!f.isOpen() && !f.alreadyClosed) {
			Iterator iter = getObservers(subject).iterator();
			while ( iter.hasNext() ) {
				updateObserver(subject, ((Observer)iter.next()));
			}
		}
	}
	pointcut flowerOpen(Subject flower):
		execution(void open()) && this(flower);
	after(Subject subject) returning : flowerOpen(subject) {
		if (subject instanceof Flower) {
			((Flower)subject).alreadyClosed = false;
		}
	}
	protected void updateObserver(Subject s, Observer o) {
		o.bedtimeSleep();
		((Flower)s).alreadyClosed = true;
	}
}
