package observer;

public class Flower {
	private boolean _isOpen;

	public Flower() {
		_isOpen = false;
	}
	public boolean isOpen() {
		return _isOpen;
	}
	private void setIsOpen(boolean newValue) {
		_isOpen = newValue;
	}
	public void open() { // Opens its petals
		System.out.println("Flower open.");
		setIsOpen(true);
	}
	public void close() { // Closes its petals
		System.out.println("Flower close.");
		setIsOpen(false);
	}
}
